#! /usr/bin/env python3 -B

import json
from testlib import check, runtests, check_text_file, check_img_file
from isrecursive import *
import copy, albero

import program

###############################################################################

def test_es3a_1():
    ''' \nProva con lista= [(1, 1, 2), (2, 2, 3)]  '''
    expected = (1, 1, 4)
    explanation = "la tripla restituita non e' corretta"
    ris = program.es3([(1, 1, 2), (2, 2, 3)])
    check(ris, expected, None, explanation)
    return 1

def test_es3a_2():
    ''' \nProva con lista=[(3,2,3),(2,4,2),(5,4,3)] '''
    expected = (2, 2, 6)
    explanation = "la tripla restituita non e' corretta"
    ris = program.es3([(3, 2, 3), (2, 4, 2), (5, 4, 3)])
    check(ris, expected, None, explanation)
    return 1

def test_es3a_3():
    ''' \nProva con lista=[(2,4,1),(4,4,1),(1,1,5),(2,2,1),(4,2,1)] '''
    expected = (1, 1, 5)
    explanation = "la tripla restituita non e' corretta"
    ris = program.es3([(2, 4, 1), (4, 4, 1), (1, 1, 5), (2, 2, 1), (4, 2, 1)])
    check(ris, expected, None, explanation)
    return 1


################################################################################
def test_es4a_1():
    ''' \nProva con l=50, e listaQuadrati= [(0,0,30),(20,20,30)] e filePng='Immagine.png' '''
    expected = {1: 1600, 0: 800, 2: 100}
    explanation = "il dizionario restituito non  e' corretto"
    ris = program.es4(50, [(0, 0, 30), (20, 20, 30)], 'Immagine.png')
    check_img_file('Immagine.png', 'RisImm.png')
    check(ris, expected, None, explanation)
    return 2


def test_es4a_2():
    ''' \nProva con l=60, e listaQuadrati=[(10,10,20),(30,30,20),(40,10,10),(20,20,20),(25,25,10)] e filePng='Immagine1.png' '''
    expected = {0: 2500, 1: 850, 2: 200, 3: 50}
    explanation = "il dizionario restituito non  e' corretto"
    ris = program.es4(60, [(10, 10, 20), (30, 30, 20), (40, 10, 10), (20, 20, 20), (25, 25, 10)], 'Immagine1.png')
    check_img_file('Immagine1.png', 'RisImm1.png')
    check(ris, expected, None, explanation)
    return 2


def test_es4a_3():
    ''' \nProva con l=100, e listaQuadrati=[(x,x,100) for x in range(10,100,10)] e filePng='Immagine2.png' '''
    expected = {0: 1900, 1: 1700, 2: 1500, 3: 1300, 4: 1100, 5: 900, 6: 700, 7: 500, 8: 300, 9: 100}
    explanation = "il dizionario restituito non  e' corretto"
    ris = program.es4(100, [(x, x, 100) for x in range(10, 100, 10)], 'Immagine2.png')
    check_img_file('Immagine2.png', 'RisImm2.png')
    check(ris, expected, None, explanation)
    return 2


################################################################################

def test_es6(dir1, expected):
    explanation = "l'insieme restituito non  e' corretto"
    decorate_module(program)
    try:
        program.es6(dir1)
    except RecursionDetectedError:
        pass
    else:
        raise Exception("Recursion not present")
    finally:
        undecorate_module(program)
    ris = program.es6(dir1)
    check(ris, expected, (dir1,), explanation)
    return 2


def test_es6a_1():
    ''' \nProva con la directory A1 '''
    expected = {'z.txt', 'c.txt', 'q.txt'}
    return test_es6('A1', expected)

def test_es6a_2():
    ''' \nProva con la directory A2 '''
    expected = {'d.txt', 'b.txt'}
    return test_es6('A2', expected)

def test_es6a_3():
    ''' \nProva con la directory A3 '''
    expected = {'r.txt', 'd.txt', 'c.txt', 'z.txt'}
    return test_es6('A3', expected)


################################################################################
def test_es10(valori, monete, expected):
    args  = (valori, monete)
    args1 = copy.deepcopy(args)
    decorate_module(program)
    try:
        program.es10(*args)
    except RecursionDetectedError:
        pass
    else:
        raise Exception("Recursion not present")
    finally:
        undecorate_module(program)
    explanation = "Risultato errato"
    ris = program.es10(*args1)
    check(ris, expected, None, explanation)
    return 3

def test_es10_1():
    """test es10 con
        valori=[10, 11, 23, 26, 27, 28]
        monete=[13, 5]
    => [1, 0, 1, 1, 0, 1]"""
    valori = [10, 11, 23, 26, 27, 28]
    monete = [13, 5]
    expected = [1, 0, 1, 1, 0, 1]
    return test_es10(valori, monete, expected)

def test_es10_2():
    """test es10 con
       valori=[1, 10, 20, 30, 40]
       monete=[2, 3, 5, 7]
    => [0, 1, 1, 1, 1]"""
    valori = [1, 10, 20, 30, 40]
    monete = [2, 3, 5, 7]
    expected = [0, 1, 1, 1, 1]
    return test_es10(valori, monete, expected)


def test_es10_3():
    """test es10 con
       valori=[1, 11, 19, 37, 43]
       monete=[8, 5]
    => [0, 0, 0, 1, 1]"""
    valori = [1, 11, 19, 37, 43]
    monete = [8, 5]
    expected = [0, 0, 0, 1, 1]
    return test_es10(valori, monete, expected)


################################################################################
def test_es14a_1():
    ''' \nProva con i file: 'f1.json','f2.json','f3.json', 'risf1.json', 'risf2.json', 'risf3.json' '''
    expected= [0,6]
    explanation = "la lista restituita non  e' corretta"
    explanation1 = "il file risf1.json non e' corretto"
    explanation2 = "il file risf2.json non e' corretto"
    explanation3 = "il file risf3.json non e' corretto"
    ris    = program.es14('f1.json','f2.json','f3.json','risf1.json','risf2.json','risf3.json')
    with open('risf1.json', encoding='utf8')as f: lista1=json.load(f)
    with open('risf2.json', encoding='utf8')as f: lista2=json.load(f)
    with open('risf3.json', encoding='utf8')as f: lista3=json.load(f)
    check(lista1,[5,6,1,0,1],None,explanation1)
    check(lista2,[0,3,5,6],None,explanation2)
    check(lista3,[0,1,3,6],None,explanation3)
    check(ris,expected,None,explanation)
    return 1

def test_es14a_2():
    ''' \nProva con i file: 'g1.json','g2.json','g3.json', 'risg1.json', 'risg2.json', 'risg3.json' '''
    expected= [0]
    explanation = "la lista restituita non  e' corretta"
    explanation1 = "il file risg1.json non e' corretto"
    explanation2 = "il file risg2.json non e' corretto"
    explanation3 = "il file risg3.json non e' corretto"
    ris    = program.es14('g1.json','g2.json','g3.json','risg1.json','risg2.json','risg3.json')
    with open('risg1.json', encoding='utf8')as f: lista1=json.load(f)
    with open('risg2.json', encoding='utf8')as f: lista2=json.load(f)
    with open('risg3.json', encoding='utf8')as f: lista3=json.load(f)
    check(lista1,[0],None,explanation1)
    check(lista2,[0],None,explanation2)
    check(lista3,[0],None,explanation3)
    check(ris,expected,None,explanation)
    return 1

def test_es14a_3():
    ''' \nProva con i file: 'h1.json','h2.json','h3.json', 'rish1.json', 'rish2.json', 'rish3.json' '''
    expected     = [33]
    explanation  = "la lista restituita non  e' corretta"
    explanation1 = "il file rish1.json non e' corretto"
    explanation2 = "il file rish2.json non e' corretto"
    explanation3 = "il file rish3.json non e' corretto"
    ris    = program.es14('h1.json','h2.json','h3.json','rish1.json','rish2.json','rish3.json')
    with open('rish1.json', encoding='utf8')as f: lista1=json.load(f)
    with open('rish2.json', encoding='utf8')as f: lista2=json.load(f)
    with open('rish3.json', encoding='utf8')as f: lista3=json.load(f)
    check(lista1,[33, 54, 92, -17, 31, 1, 2, 3, 4, 6] ,    None, explanation1)
    check(lista2,[123, 72, 99, 33, 2, 3, 4, 6, 49, -200],  None, explanation2)
    check(lista3,[33, 54, 92, -17, 31, 1, 123, 72, 99, 49, -200] ,  None, explanation3)
    check(ris,expected,None,explanation)
    return 1

################################################################################
def test_es20(tree, expected):
    args = (tree,)
    explanation = "Il diametro dell'albero non è corretto"
    args1 = copy.deepcopy(args)
    decorate_module(program)
    try:
        program.es20(*args1)
    except RecursionDetectedError:
        pass
    else:
        raise Exception("Recursion not present")
    finally:
        undecorate_module(program)
    ris = program.es20(*args)
    check(ris, expected, args, explanation)
    return 3

def test_es20_1():
    '''
    Diametro dell'albero
             1          .
            /\          .
           2  3         .
          / \           .
        4    5          .
       /    /           .
      6    7            .
     /     \            .
     8      9           .
    Il risultato dev'essere 7
    '''
    lista = [1, [2, [4, [6, [8, None, None], None], None], [5, [7, None, [9, None, None]], None]], [3, None, None]]
    tree  = albero.AlberoBinario.fromList(lista)
    expected = 7
    return test_es20(tree, expected)

def test_es20_2():
    '''
    Diametro dell'albero
    [255197, [633928, [504898, None, [444647, [618336, None, [135295, None, [403880, None, [447206, None, [690827, [478339, None, None], [23577, None, None]]]]]], [745301, None, None]]], [692411, [192501, None, [307256, [315871, [136132, None, [231806, [822980, None, [608643, None, None]], [673946, None, [510695, None, None]]]], [949865, [105739, [755766, [837093, None, None], [643702, None, None]], [660710, [100570, None, None], None]], [987925, [142062, [874365, None, None], [543082, None, None]], [179907, [923260, None, None], [653956, None, None]]]]], [666133, [149691, [54130, None, [555642, [690993, None, None], [708084, None, None]]], [197326, [587093, [449743, None, None], [322590, None, None]], [20822, [812525, None, None], [464026, None, None]]]], [552254, [804041, [693303, None, [251073, None, None]], [982051, [675429, None, None], [756408, None, None]]], [562210, [626296, [48420, None, None], None], None]]]]], None]], [99958, [591631, [88838, [416270, [434459, [271515, [249184, None, [859993, None, [64114, None, None]]], [630599, [489990, [579895, None, None], [359467, None, None]], [115230, None, [584075, None, None]]]], [710576, [303763, [124029, [863844, None, None], [714619, None, None]], [700437, [944599, None, None], None]], [667413, [424691, [436215, None, None], [359581, None, None]], [283517, [68964, None, None], [353252, None, None]]]]], [653800, [749255, None, None], [546358, [348473, [414236, [81958, None, None], None], [868324, [582666, None, None], [29587, None, None]]], [742587, [347714, [983971, None, None], [280843, None, None]], [238890, [448496, None, None], [959455, None, None]]]]]], [445851, [175866, [728117, [431763, [203473, [618029, None, None], [921823, None, None]], [134105, [762063, None, None], [546729, None, None]]], [318015, [106081, [22450, None, None], [986144, None, None]], [362911, [581171, None, None], [147867, None, None]]]], None], [700237, [723930, [95391, None, [780996, [756761, None, None], [374668, None, None]]], [791249, [978699, [562210, None, None], [810643, None, None]], [989296, [422502, None, None], None]]], [247756, [36098, [840873, [642928, None, None], [631046, None, None]], [754774, [547171, None, None], [981401, None, None]]], [738838, [630947, [526893, None, None], [435886, None, None]], [767032, [961895, None, None], [380901, None, None]]]]]]], [625356, [535672, [499526, [80346, [782360, [376095, [435914, None, None], [215725, None, None]], [732243, [438742, None, None], [22905, None, None]]], [314041, [743338, [814678, None, None], [232213, None, None]], [441385, [13425, None, None], [973643, None, None]]]], [236358, [709286, [455367, [221430, None, None], [88450, None, None]], [269730, [977459, None, None], [786030, None, None]]], [795129, [187518, [928366, None, None], [6505, None, None]], [807957, [91918, None, None], [267755, None, None]]]]], [950494, None, [233855, [485632, [267405, [969416, None, None], [101275, None, None]], [106433, [676252, None, None], [909043, None, None]]], [453356, [868068, None, [821470, None, None]], None]]]], [259584, [616091, [530, [786634, [962038, [9681, None, None], [533895, None, None]], [90532, [574246, None, None], [456538, None, None]]], [432592, [190483, [153924, None, None], [308937, None, None]], [946589, [345704, None, None], [418919, None, None]]]], [415451, None, [767767, [980872, None, [287700, None, None]], [33221, [620956, None, None], [617270, None, None]]]]], [641367, None, [675444, [170988, [686182, [505783, None, None], [576646, None, None]], [515993, [901821, None, None], [390412, None, None]]], [641117, [342921, [708829, None, None], None], [762138, [150236, None, None], None]]]]]]], [791307, [732861, None, [555901, [412490, [126772, [325366, [591580, [383017, None, None], [764990, None, None]], None], [319008, [928468, [466448, None, None], [7862, None, None]], [226030, [828084, None, None], [163931, None, None]]]], [59079, None, [203341, [316159, None, [68260, None, None]], [107784, None, [653049, None, None]]]]], [772014, [137911, [751853, [844951, [61018, None, None], [486760, None, None]], [677643, [441773, None, None], [301947, None, None]]], [721232, [350726, [233566, None, None], [576712, None, None]], [647949, [227581, None, None], [581532, None, None]]]], [955532, [321400, None, [737101, None, [133686, None, None]]], [117699, None, [189094, [645260, None, None], [880003, None, None]]]]]]], [70507, [105714, [140939, [868867, [648221, [60635, [742069, None, None], None], [671103, [220251, None, None], [834947, None, None]]], [394401, [477635, [825633, None, None], [879608, None, None]], [421941, [142514, None, None], None]]], [86601, [549094, None, [359389, [770909, None, None], [711469, None, None]]], [791957, [299604, [466169, None, None], [440956, None, None]], [170484, [855559, None, None], [341504, None, None]]]]], [453323, [184352, [196611, None, [518385, [80030, None, None], None]], [408392, [416294, [517229, None, None], [710270, None, None]], [861102, [290578, None, None], [421757, None, None]]]], [276421, [665112, [784798, [385068, None, None], [19426, None, None]], [940547, [11382, None, None], None]], [149083, None, [436378, [187477, None, None], [481617, None, None]]]]]], [141156, [735923, [134579, [604073, [762691, [455202, None, None], [385409, None, None]], [350250, [501032, None, None], [514251, None, None]]], None], [608574, [743878, [415525, [347617, None, None], [182870, None, None]], [543604, [734365, None, None], [532386, None, None]]], [128009, [845449, [788794, None, None], [37116, None, None]], [610600, [294578, None, None], [598833, None, None]]]]], [672157, None, [751506, [790732, [791447, [367589, None, None], [93994, None, None]], [707600, [928142, None, None], None]], [13659, [271812, [578842, None, None], [632769, None, None]], [703303, None, [372781, None, None]]]]]]]]]]
    Il risultato dev'essere 19
    '''
    lista = [255197, [633928, [504898, None, [444647, [618336, None, [135295, None, [403880, None, [447206, None, [690827, [478339, None, None], [23577, None, None]]]]]], [745301, None, None]]], [692411, [192501, None, [307256, [315871, [136132, None, [231806, [822980, None, [608643, None, None]], [673946, None, [510695, None, None]]]], [949865, [105739, [755766, [837093, None, None], [643702, None, None]], [660710, [100570, None, None], None]], [987925, [142062, [874365, None, None], [543082, None, None]], [179907, [923260, None, None], [653956, None, None]]]]], [666133, [149691, [54130, None, [555642, [690993, None, None], [708084, None, None]]], [197326, [587093, [449743, None, None], [322590, None, None]], [20822, [812525, None, None], [464026, None, None]]]], [552254, [804041, [693303, None, [251073, None, None]], [982051, [675429, None, None], [756408, None, None]]], [562210, [626296, [48420, None, None], None], None]]]]], None]], [99958, [591631, [88838, [416270, [434459, [271515, [249184, None, [859993, None, [64114, None, None]]], [630599, [489990, [579895, None, None], [359467, None, None]], [115230, None, [584075, None, None]]]], [710576, [303763, [124029, [863844, None, None], [714619, None, None]], [700437, [944599, None, None], None]], [667413, [424691, [436215, None, None], [359581, None, None]], [283517, [68964, None, None], [353252, None, None]]]]], [653800, [749255, None, None], [546358, [348473, [414236, [81958, None, None], None], [868324, [582666, None, None], [29587, None, None]]], [742587, [347714, [983971, None, None], [280843, None, None]], [238890, [448496, None, None], [959455, None, None]]]]]], [445851, [175866, [728117, [431763, [203473, [618029, None, None], [921823, None, None]], [134105, [762063, None, None], [546729, None, None]]], [318015, [106081, [22450, None, None], [986144, None, None]], [362911, [581171, None, None], [147867, None, None]]]], None], [700237, [723930, [95391, None, [780996, [756761, None, None], [374668, None, None]]], [791249, [978699, [562210, None, None], [810643, None, None]], [989296, [422502, None, None], None]]], [247756, [36098, [840873, [642928, None, None], [631046, None, None]], [754774, [547171, None, None], [981401, None, None]]], [738838, [630947, [526893, None, None], [435886, None, None]], [767032, [961895, None, None], [380901, None, None]]]]]]], [625356, [535672, [499526, [80346, [782360, [376095, [435914, None, None], [215725, None, None]], [732243, [438742, None, None], [22905, None, None]]], [314041, [743338, [814678, None, None], [232213, None, None]], [441385, [13425, None, None], [973643, None, None]]]], [236358, [709286, [455367, [221430, None, None], [88450, None, None]], [269730, [977459, None, None], [786030, None, None]]], [795129, [187518, [928366, None, None], [6505, None, None]], [807957, [91918, None, None], [267755, None, None]]]]], [950494, None, [233855, [485632, [267405, [969416, None, None], [101275, None, None]], [106433, [676252, None, None], [909043, None, None]]], [453356, [868068, None, [821470, None, None]], None]]]], [259584, [616091, [530, [786634, [962038, [9681, None, None], [533895, None, None]], [90532, [574246, None, None], [456538, None, None]]], [432592, [190483, [153924, None, None], [308937, None, None]], [946589, [345704, None, None], [418919, None, None]]]], [415451, None, [767767, [980872, None, [287700, None, None]], [33221, [620956, None, None], [617270, None, None]]]]], [641367, None, [675444, [170988, [686182, [505783, None, None], [576646, None, None]], [515993, [901821, None, None], [390412, None, None]]], [641117, [342921, [708829, None, None], None], [762138, [150236, None, None], None]]]]]]], [791307, [732861, None, [555901, [412490, [126772, [325366, [591580, [383017, None, None], [764990, None, None]], None], [319008, [928468, [466448, None, None], [7862, None, None]], [226030, [828084, None, None], [163931, None, None]]]], [59079, None, [203341, [316159, None, [68260, None, None]], [107784, None, [653049, None, None]]]]], [772014, [137911, [751853, [844951, [61018, None, None], [486760, None, None]], [677643, [441773, None, None], [301947, None, None]]], [721232, [350726, [233566, None, None], [576712, None, None]], [647949, [227581, None, None], [581532, None, None]]]], [955532, [321400, None, [737101, None, [133686, None, None]]], [117699, None, [189094, [645260, None, None], [880003, None, None]]]]]]], [70507, [105714, [140939, [868867, [648221, [60635, [742069, None, None], None], [671103, [220251, None, None], [834947, None, None]]], [394401, [477635, [825633, None, None], [879608, None, None]], [421941, [142514, None, None], None]]], [86601, [549094, None, [359389, [770909, None, None], [711469, None, None]]], [791957, [299604, [466169, None, None], [440956, None, None]], [170484, [855559, None, None], [341504, None, None]]]]], [453323, [184352, [196611, None, [518385, [80030, None, None], None]], [408392, [416294, [517229, None, None], [710270, None, None]], [861102, [290578, None, None], [421757, None, None]]]], [276421, [665112, [784798, [385068, None, None], [19426, None, None]], [940547, [11382, None, None], None]], [149083, None, [436378, [187477, None, None], [481617, None, None]]]]]], [141156, [735923, [134579, [604073, [762691, [455202, None, None], [385409, None, None]], [350250, [501032, None, None], [514251, None, None]]], None], [608574, [743878, [415525, [347617, None, None], [182870, None, None]], [543604, [734365, None, None], [532386, None, None]]], [128009, [845449, [788794, None, None], [37116, None, None]], [610600, [294578, None, None], [598833, None, None]]]]], [672157, None, [751506, [790732, [791447, [367589, None, None], [93994, None, None]], [707600, [928142, None, None], None]], [13659, [271812, [578842, None, None], [632769, None, None]], [703303, None, [372781, None, None]]]]]]]]]]
    tree = albero.AlberoBinario.fromList(lista)
    expected = 19
    return test_es20(tree, expected)

def test_es20_3():
    '''
    Diametro dell'albero
    [112971, [411643, [844377, [402185, [374694, [127027, None, None], None], None], [815078, [527677, None, None], [597500, None, None]]], [213329, [861244, [140656, [439740, None, [844929, None, None]], [904762, None, None]], [689832, [840104, [298104, [270693, None, None], [451414, None, None]], [870110, None, None]], None]], [514754, [109894, [101558, None, None], [398000, None, None]], [3174, [815070, None, None], [712176, None, None]]]]], [11055, [506022, [30910, None, [156286, None, None]], [63489, None, [958210, None, None]]], [324776, [967111, [250990, [399317, None, None], [247182, None, None]], [418707, None, [161330, None, None]]], [747574, [20629, [986662, None, None], [379426, None, None]], [67213, None, None]]]]]
    Il risultato dev'essere 13
    '''
    lista = [112971, [411643, [844377, [402185, [374694, [127027, None, None], None], None], [815078, [527677, None, None], [597500, None, None]]], [213329, [861244, [140656, [439740, None, [844929, None, None]], [904762, None, None]], [689832, [840104, [298104, [270693, None, None], [451414, None, None]], [870110, None, None]], None]], [514754, [109894, [101558, None, None], [398000, None, None]], [3174, [815070, None, None], [712176, None, None]]]]], [11055, [506022, [30910, None, [156286, None, None]], [63489, None, [958210, None, None]]], [324776, [967111, [250990, [399317, None, None], [247182, None, None]], [418707, None, [161330, None, None]]], [747574, [20629, [986662, None, None], [379426, None, None]], [67213, None, None]]]]]
    tree  = albero.AlberoBinario.fromList(lista)
    expected = 13
    return test_es20(tree, expected)

################################################################################

tests = [
    #test_es3a_1, test_es3a_2, test_es3a_3,
    #test_es4a_1, test_es4a_2, test_es4a_3,
    #test_es6a_1, test_es6a_2, test_es6a_3,
    test_es10_1, test_es10_2, test_es10_3,
    #test_es14a_1, test_es14a_2, test_es14a_3,
    #test_es20_1, test_es20_2, test_es20_3,
]

if __name__ == '__main__':
    # runtests(tests)
    runtests(tests, logfile='grade.csv')

################################################################################


