'''
Progettate una o piu' delle seguenti funzioni
(all'inizio di ogni funzione viene specificato il numero di punti assegnato dal grader a quella funzione)
Il punteggio complessivo dato dal grader e' il voto della prova di recupero.
Se la somma dei punteggi ottenuti con gli esercizi e' maggiore di 32, si otterra' il punteggio 32.

NOTA: il grader testa tutte le funzioni, quindi stampera' degli errori per le funzioni non implementate
NOTA: è VIETATO usare la funzione os.walk

!!!ATTENZIONE!!! è VIETATO aggiungere argomenti alle funzioni,
    (per evitare problemi con i valori di default mutabili)
    piuttosto usate delle funzioni di appoggio e passate loro gli argomenti aggiuntivi necessari
'''


###############################################################################################
def es3(lista):
    '''
    Es 3: 3 punti (bounding-box quadrato)
    La funzione es3(lista) prende in input  una lista contenente triple ciascuna
    delle quali individua un quadrato nel piano.
    La tripla (x,y,l) rappresenta un quadrato di lato  l il cui spigolo in alto a sinistra
    e' posizionato sul piano nel punto (x,y).
    La funzione deve restituire la tripla che rappresenta il quadrato di lato minimo
    in grado di ricoprire tutti i quadrati della lista.

    Ad esempio per lista= [(1, 1, 2), (2, 2, 3)] la funzione restituisce il quadrato (1,1,4)
    '''
    # inserisci qui il tuo codice
    # il minino quadrato ha x minima, y minima e lato = massimo(xmax-xmin, ymax-ymin)
    xmin = min(lista, key=lambda q: q[0])[0]
    xmax = max(lista, key=lambda q: q[0] + q[2])
    xmax = xmax[0] + xmax[2]
    ymin = min(lista, key=lambda q: q[1])[1]
    ymax = max(lista, key=lambda q: q[1] + q[2])
    ymax = ymax[0] + ymax[2]
    lato = max(xmax - xmin, ymax - ymin)
    return (xmin, ymin, lato)


###############################################################################################
import immagini
def es4(l, listaQuadrati, filePng):
    '''
    Es 4: 6 punti
    La funzione es4(l,listaQuadrati,filePng) prende in input
    - un intero l
    - una lista listaQuadrati contenente informazioni su quadrati nel piano. Ciascun
      elemento della lista e' una tripla (x,y,lato). La tripla (x,y,lato) denota un
      quadrato di lato 'lato' il cui spigolo in alto a sinistra e' posizionato sul piano nel punto (x,y).
    - l'indirizzo filePng di un file .png
    La funzione restituisce un dizionario di interi e salva all'indirizzo filePng in formato .png una
    immagine quadrata di lato 'lato' contenente i quadrati indicati dalla lista listaQuadrati.
    Lo sfondo iniziale dell'immagine e' nero (0,0,0) poi, in sequenza per ogni quadrato (x,y,lato)
    della lista, sull'immagine viene disegnato il quadrato di lato 'lato' con spigolo in altro a sinistra
    in posizione (x,y).
    (nota: se il quadrato sborda dall'immagine vanno colorati solo i pixel ad essa appartenenti)
    I pixel del quadrato da colorare assumono il colore bianco (255,255,255) se di colore nero,
    assumono il colore nero altrimenti.
    Le chiavi del dizionario restituito sono degli interi.
    L'intero x appartiene al dizionario se nell'immagine ci sono pixel su cui si sono sovrapposti
    esattamente x quadrati.
    L'attributo di x nel dizionario e' il numero di pixel dell'immagine su cui insistono esattamente
    x quadrati.

    Ad esempio con l=50, e listaQuadrati= [(0,0,30),(20,20,30)] e filePng='Immagine.png' la funzione
    es3(l,listaQuadrati,filePng) oltre a creare l'immagine di 50 per 50 pixel nel file prova.png
    restituira' anche il dizionario {1: 1600, 0: 800, 2: 100}
	'''
    # inserisci qui il tuo codice
    img = [[(0, 0, 0) for _ in range(l)] for _ in range(l)]
    conta = [[0 for _ in range(l)] for _ in range(l)]
    for x, y, l in listaQuadrati:
        disegnaQuadrato(img, x, y, l, conta)
    immagini.save(img, filePng)
    conteggi = {}
    for line in conta:
        for c in line:
            if c in conteggi:
                conteggi[c] += 1
            else:
                conteggi[c] = 1
    return conteggi


bianco = (255, 255, 255)
nero = (0, 0, 0)


def disegnaQuadrato(img, x, y, l, conteggio):
    for X in range(x, x + l):
        for Y in range(y, y + l):
            try:
                img[Y][X] = bianco if img[Y][X] == nero else nero
                conteggio[Y][X] += 1
            except:
                pass


###############################################################################################
import os

def es6(dir1):
    '''
    Es. 6: 6 punti

    ATTENZIONE: usate come separatore dei file il carattere "/" che funziona sia in Windows che in Linux
    ATTENZIONE: e' VIETATO usare la funzione os.walk

    Si definisca la funzione  es6(dir1), ricorsiva o che chiama una vostra funzione ricorsiva,
    che preso in input il path dir1 di una directory esegue il seguente lavoro:

    Ricerca nella directory il cui path e'  dir1 e nelle sue subdirectories
    eventuali file con estensione .txt.
    Al termine la funzione restituisce un insieme  coi nomi di tutti i file individuati.
    Se vengono individuati  piu' file con lo stesso nome allora nessuno di essi va inserito nell'insieme.
    I file nascosti (i.e. quelli che iniziano con '.') che si incontrano nell'esplorazione delle varie
    sottocartelle non vanno considerati.
    '''
    # inserite qui il vostro codice
    tutti = _es6(dir1)
    conta = {}
    for f in tutti:
        if f in conta:
            conta[f] += 1
        else:
            conta[f] = 1
    return set(k for k, v in conta.items() if v == 1)


def _es6(dir1):
    trovati = []
    for f in os.listdir(dir1):
        if f[0] == '.':
            continue
        fn = dir1 + '/' + f
        if os.path.isdir(fn):
            trovati += _es6(fn)
        elif f[-4:] == '.txt':
            trovati.append(f)
    return trovati

############################################################################################
def es10(lista1, lista2):  # questo nell'esame non lo mettiamo
    '''
    Es. 10:  9 punti

    Abbiamo due liste di interi lista1 e lista2 per ogni elemento di lista1 vogliamo sapere se e' esprimibile
    sommando (anche piu' volte ) interi presenti nella lista2.
    Si definisca la funzione ricorsiva (o che usa una vostra funzione ricorsiva) es10(lista1, lista2)
    che, prese le due liste, restituisce una terza lista della stessa lunghezza di lista1.
    La terza lista lista3 contiene solo zeri e/o uni.
    Per ogni i, il valore lista3[i] sara' uno se l'intero lista1[i] e' esprimibile come somma degli
    interi presenti in lista2 (presi anche più volte), sara' zero altrimenti.
    Ad esempio per
    lista1=[ 10, 11, 23,26,27,28]
    lista2=[ 13,5]
    es4(lista1,lista2) restituisce [1, 0, 1, 1, 0, 1]
    perche'
    10 = 5+5
    11 non è ottenibile come somma di soli interi appartenenti a [13, 5]
    23 = 13+5+5
    26 = 13+13
    27 non è ottenibile come somma di soli interi appartenenti a [13, 5]
    28 = 13+5+5+5

    SUGGERIMENTO:   se il numero da esaminare è proprio uno dei valori di lista2 ...
                    se è più piccolo di tutti i valori   ...
                    altrimenti bisogna provare con tutti valori di lista2 che sono più piccoli del numero
    '''
    # inserisci qui il tuo codice
    return [cambiabile(n, lista2) for n in lista1]

def cambiabile(n, monete):
    # se tutte le monete sono maggiori di n => 0
    # (non serve, è implicato dalla regola ricorsiva)
    # if all( m > n for m in monete):
    #     return 0
    # se n è una moneta => 1
    if n in monete:
        return 1
    # se una moneta è minore di n e il resto è cambiabile => 1
    return 1 if any(m < n and cambiabile(n - m, monete) for m in monete) else 0


###############################################################################################
import json

def es14(fnome1,fnome2, fnome3, ofnome1, ofnome2, ofnome3):
    '''
    Es 14: 3 punti
    progettare la funzione es14(fnome1,fnome2, fnome3,ofnome1, ofnome2, ofnome3) che
    prende in input il nome di 6 file json contenenti liste di interi e,
    salva nel file ofnome1  la lista che era contenuta nel file fnome1 dopo avervi
    cancellato gli interi che non compaiono in almeno due dei tre file fnome1, fnome2 e fnome3.
    Effettua poi la stessa operazione anche per la coppia di file   ofnome2 e fnome2 e la coppia di file
    ofnome3 e fnome3.
    Inoltre la funzione deve restituire la lista dei valori comuni alle   tre  liste
    in fnome1,fnome2 e fnome3.
    La lista restituita deve risultare ordinata in modo crescente.

    Ad esempio: se i tre file contengono nell'ordine le seguenti tre liste:
    l1=[5,6,7,1,0,1]
    l2=[0,3,5,6,8,8]
    l3=[0,1,3,4,6,9]
    allora al termine i tre file ofnome1, ofnome2,ofnome3 conterranno nell'ordine le liste:
    [5,6,1,0,1]
    [0,3,5,6]
    [0,1,3,6]
    e la funzione restituira'  la lista
    [0,6]
    '''
    # inserisci qui il tuo codice
    with open(fnome1, encoding='utf8') as f:
        lista1 = json.load(f)
    with open(fnome2, encoding='utf8') as f:
        lista2 = json.load(f)
    with open(fnome3, encoding='utf8') as f:
        lista3 = json.load(f)
    LL = (lista1, lista2, lista3)
    count1 = [i for i in lista1 if almeno2(i, LL)]
    count2 = [i for i in lista2 if almeno2(i, LL)]
    count3 = [i for i in lista3 if almeno2(i, LL)]
    with open(ofnome1, mode='w', encoding='utf8') as f:
        json.dump(count1, f)
    with open(ofnome2, mode='w', encoding='utf8') as f:
        json.dump(count2, f)
    with open(ofnome3, mode='w', encoding='utf8') as f:
        json.dump(count3, f)
    return sorted([x    for x in set(lista1 + lista2 + lista3)
                        if x in lista1 and x in lista2 and x in lista3])

def almeno2(n, LL):
    c = 0
    for L in LL:
        if n in L:
            c+=1
    return c > 1

###############################################################################################
import albero
def es20(tree):
    '''
    Es 20: 9 punti
    Si definisca la funzione ricorsiva (o che fa uso di funzioni o metodi ricorsive/i) che:
    - riceve come argomento 'tree' un albero binario formato di nodi di tipo AlberoBinario
        definito nella libreria albero.py allegata
    - calcola il diametro dell'albero, ovvero la lunghezza del più lungo cammino
        che parte da una foglia ed arriva ad una foglia (contando i nodi che lo compongono)
    - torna come risultato il diametro trovato
    Nota: il più lungo cammino potrebbe non passare per la radice dell'albero
    Esempio: se l'albero è
             1
            /\
           2  3
          / \
        4    5
       /    /
      6    7
     /     \
     8      9
     Il cammino più lungo è 8-6-4-2-5-7-9 e la funzione tornerà il valore 7

     SUGGERIMENTO: la lunghezza del più lungo cammino che passa per una certa radice
     è facilmente calcolabile conoscendo l'altezza massima dei due sottoalberi di quella radice
     Quindi la funzione ricorsiva deve fornire almeno due valori: altezza massima e cammino massimo
    '''
    # inserisci qui il tuo codice
    (maxH, maxC) = _es20(tree)
    return maxC

def _es20(tree):
    if not tree:                            # se l'albero è vuoto
        return (0, 0)                       # torno altezza 0 e cammino 0
    else:
        (maxHsx, maxCsx) = _es20(tree.sx)   # esamino il sinistro
        (maxHdx, maxCdx) = _es20(tree.dx)   # esamino il destro
        maxH = max(maxHsx, maxHdx) + 1      # l'altezza massima è 1 + la massima tra i due
        maxC = maxHsx + maxHdx + 1          # se il cammino massimo passa qui ha lunghezza Hsx+Hdx+1
        maxC = max(maxC, maxCsx, maxCdx)    # ma potrebbe non essere il massimo
        return (maxH, maxC)                 # torno mahH e maxC calcolati

###############################################################################################
